'use strict';

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _extends = require('babel-runtime/helpers/extends')['default'];

var _objectWithoutProperties = require('babel-runtime/helpers/object-without-properties')['default'];

var _Object$assign = require('babel-runtime/core-js/object/assign')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _OptionJs = require('./Option.js');

var _OptionJs2 = _interopRequireDefault(_OptionJs);

var Select = (function (_React$Component) {
    _inherits(Select, _React$Component);

    function Select(props) {
        var _this = this;

        _classCallCheck(this, Select);

        _React$Component.call(this, props);
        this.loadData = [];
        this.focus = -1;
        this.state = {
            data: [],
            open: props.open,
            type: props.type,
            selected: [],
            selectedData: [],
            openSearch: this.props.openSearch
        };
        this.getSelectOption = function () {
            return _this.state.selectedData;
        };
        this.getAllOption = function () {
            return _this.state.data;
        };
        this.isSelectAll = function () {
            return _this.state.data.length === _this.state.selectedData.length;
        };
        this.getValue = function () {
            var value = [];
            _this.state.selectedData.forEach(function (item) {
                return value.push(item.value);
            });
            return value;
        };
        this.getText = function () {
            var text = [];
            _this.state.selectedData.forEach(function (item) {
                return text.push(item.text);
            });
            return text;
        };
    }

    Select.prototype.componentWillMount = function componentWillMount() {
        var _this2 = this;

        var children = [],
            loadData = [],
            value = [],
            text = [],
            selected = [];
        this.loadData = [];
        if (this.props.children) {
            if (this.props.children instanceof Array) {
                this.props.children.map(function (item) {
                    if (item instanceof Array) {
                        children = children.concat(item);
                    } else {
                        children.push(item);
                    }
                });
            } else {
                children.push(this.props.children);
            }
            children.forEach(function (item, index) {

                var option = {
                    value: item.props.value,
                    text: item.props.children
                };

                _this2.loadData.push(option);

                // 优先selectAll -> 匹配value  , -> 匹配selected
                if (_this2.props.type === "multiple" && _this2.props.selectAll) {
                    text.push(item.props.children);
                    value.push(option);
                    selected.push(index);
                } else if (_this2.props.value !== undefined) {
                    (function () {
                        var values = _this2.props.value;
                        switch (typeof _this2.props.value) {
                            case 'string':
                                (function () {
                                    if (values == item.props.value) {
                                        text.push(item.props.children);
                                        value.push(option);
                                        selected.push(index);
                                    }
                                })();break;
                            case 'object':
                                (function () {
                                    if (values.length > 0) {
                                        values.map(function (val) {
                                            if (val == item.props.value) {
                                                text.push(item.props.children);
                                                value.push(option);
                                                selected.push(index);
                                            }
                                        });
                                    }
                                })();break;
                        }
                    })();
                } else if (_this2.props.selected !== undefined) {
                    (function () {
                        var selects = _this2.props.selected;
                        switch (typeof _this2.props.selected) {
                            case 'number':
                                (function () {
                                    if (index == selects) {
                                        text.push(item.props.children);
                                        value.push(option);
                                        selected.push(index);
                                    }
                                })();break;
                            case 'object':
                                (function () {
                                    if (selects.length > 0) {
                                        selects.map(function (select) {
                                            if (index == select) {
                                                text.push(item.props.children);
                                                value.push(option);
                                                selected.push(index);
                                            }
                                        });
                                    }
                                })();break;
                        }
                    })();
                }
            });
        }
        this.setState(_extends({}, this.state, {
            text: text,
            data: this.loadData,
            selected: selected,
            selectedData: value
        }));
    };

    Select.prototype.componentDidMount = function componentDidMount() {
        var _this3 = this;

        window.addEventListener('click', function (event) {
            _this3.globalMouseClick(event);
        });

        this.refs.myselect.getElementsByClassName('myselect-body-scroll').scrollTop = 0;
    };

    Select.prototype.componentWillUnmount = function componentWillUnmount() {
        window.removeEventListener('click', this.globalMouseClick);
    };

    Select.prototype._generateHead = function _generateHead() {
        var _this4 = this;

        var text = this.state.text;

        var searchInput = function searchInput() {
            return _react2['default'].createElement('input', { type: 'text', className: 'search-input', value: text, title: text, onClick: _this4.onHandClick.bind(_this4), onChange: _this4.onHandChange.bind(_this4) });
        };

        var innerText = function innerText() {
            switch (_this4.props.type) {
                case 'single':
                    return (function () {
                        return searchInput();
                    })();
                case 'multiple':
                    return (function () {
                        if (_this4.props.openSearch) {
                            var showText = undefined;
                            console.log(_this4.state.text);
                            if (_this4.state.text.length > 0 && _this4.state.text.length > _this4.props.showMultipleSize) {
                                showText = _this4.state.selectedData.length + " " + _this4.props.outSelectSizeText;
                            } else {
                                showText = text;
                            }
                            return _react2['default'].createElement('input', { type: 'text', className: 'search-input', value: showText, title: text, onClick: _this4.onHandClick.bind(_this4), onChange: _this4.onHandChange.bind(_this4) });
                        } else {
                            return text && text instanceof Array ? text.map(function (item, index) {
                                return _react2['default'].createElement(
                                    'div',
                                    { key: index, className: 'multipleItem' },
                                    _react2['default'].createElement(
                                        'span',
                                        { className: 'Select-value-icon', onClick: _this4.removeItem.bind(_this4, index) },
                                        '×'
                                    ),
                                    _react2['default'].createElement(
                                        'span',
                                        { className: 'Select-value-label', onClick: _this4.onHandClick.bind(_this4), title: item },
                                        item
                                    )
                                );
                            }) : _react2['default'].createElement(
                                'span',
                                null,
                                text
                            );
                        }
                    })();
            }
        };

        return _react2['default'].createElement(
            'div',
            { onClick: function () {
                    return _this4.toggleMenu();
                } },
            _react2['default'].createElement(
                'div',
                { className: 'myselect-head' },
                _react2['default'].createElement(
                    'div',
                    { className: 'items', ref: 'multipleItem' },
                    innerText()
                ),
                _react2['default'].createElement(
                    'div',
                    { className: 'dropdown-toggle' },
                    _react2['default'].createElement('i', null)
                )
            )
        );
    };

    Select.prototype._generateBody = function _generateBody() {
        var _this5 = this;

        var body = '';
        if (Array.isArray(this.state.data)) {
            body = this.state.data.map((function (item, i) {
                var selected = false,
                    focused = false;

                this.focus == i ? focused = true : '';

                typeof this.state.selected == 'object' ? this.state.selected.map(function (item) {
                    return item == i ? selected = true : '';
                }) : '';

                return _react2['default'].createElement(
                    'div',
                    { key: i },
                    _react2['default'].createElement(_OptionJs2['default'], {
                        item: item,
                        selected: selected,
                        index: i,
                        focused: focused,
                        hasIcon: this.props.hasIcon,
                        type: this.state.type,
                        selectItem: this.selectItem.bind(this),
                        focusItem: this.focusItem.bind(this)
                    })
                );
            }).bind(this));
        }

        var _renderBody = function _renderBody() {
            return body && body.length > 0 ? body : _react2['default'].createElement(
                'div',
                { className: 'no-data' },
                _react2['default'].createElement(
                    'div',
                    { className: 'text' },
                    _this5.props.noSearchDataTips
                )
            );
        };

        return _react2['default'].createElement(
            'div',
            null,
            _react2['default'].createElement(
                'div',
                { className: 'myselect-body', style: { maxHeight: this.props.maxHeight } },
                _react2['default'].createElement(
                    'div',
                    { className: 'myselect-body-scroll' },
                    this.props.type == "multiple" && this.state.data.length > 0 ? _react2['default'].createElement(
                        'div',
                        { className: 'myselect-opration' },
                        _react2['default'].createElement(
                            'a',
                            { href: 'javascript:;', onClick: this.selectAll.bind(this) },
                            '全选'
                        ),
                        '/',
                        _react2['default'].createElement(
                            'a',
                            { href: 'javascript:;', onClick: this.unSelectAll.bind(this) },
                            '全不选'
                        )
                    ) : null,
                    _renderBody()
                )
            )
        );
    };

    Select.prototype.onHandChange = function onHandChange(e) {
        e.stopPropagation();
        if (this.props.openSearch) {
            this.filterBySearch();
        }
    };

    Select.prototype.onHandClick = function onHandClick(e) {
        var _this6 = this;

        e.stopPropagation();

        var selected = [];

        if (this.state.selectedData && this.state.selectedData.length > 0) {
            // 序列重置
            this.loadData.map(function (item, index) {
                _this6.state.selectedData.forEach(function (select) {
                    if (select.value === item.value) {
                        selected.push(index);
                    }
                });
            });
        }
        if (!this.state.open) {
            if (this.props.openSearch && this.props.type === "multiple") {
                this.setState(_extends({}, this.state, {
                    open: true,
                    text: [],
                    selected: selected,
                    data: this.loadData
                }));
            } else {
                this.setState(_extends({}, this.state, {
                    open: true,
                    selected: selected,
                    data: this.loadData
                }));
            }
        } else {
            if (this.props.openSearch && this.props.type === "multiple") {
                this.setState(_extends({}, this.state, {
                    open: true,
                    text: [],
                    selected: selected,
                    data: this.loadData
                }));
            }
        }
    };

    Select.prototype.focusItem = function focusItem(focus) {
        this.focus = focus;
    };

    Select.prototype.filterBySearch = function filterBySearch() {
        var _this7 = this;

        var filter = this.refs.myselect.getElementsByClassName('search-input')[0].value;

        var data = [],
            selected = [];

        this.loadData.forEach(function (item, index) {
            if (item.text.toString().toLowerCase().indexOf(filter.toLowerCase()) > -1) {
                data.push(item);
            }
        });

        // 重新匹配是否有选中
        switch (this.props.type) {
            case 'single':
                (function () {
                    data.map(function (item, index) {
                        if (_this7.state.selectedData && _this7.state.selectedData.length > 0) {
                            if (_this7.state.selectedData[0].value === item.value) {
                                selected.push(index);
                            }
                        }
                    });
                })();break;
            case 'multiple':
                (function (item, index) {
                    data.map(function (item, index) {
                        if (_this7.state.selectedData && _this7.state.selectedData.length > 0) {
                            // 序列重置
                            _this7.state.selectedData.forEach(function (select) {
                                if (select.value === item.value) {
                                    selected.push(index);
                                }
                            });
                        }
                    });
                })();break;
        }

        this.setState(_extends({}, this.state, {
            text: [filter],
            data: data,
            selected: selected
        }));
    };

    Select.prototype.toggleMenu = function toggleMenu() {
        var myselect = this.refs.myselect;

        this.setState(_extends({}, this.state, {
            open: !this.state.open
        }));
    };

    Select.prototype.hasItemIndex = function hasItemIndex(item) {
        var index = -1;
        this.state.selectedData.forEach(function (select, i) {
            if (select.value == item.value) {
                index = i;
            }
        });
        return index;
    };

    Select.prototype.selectItem = function selectItem(item) {
        var _this8 = this;

        var text = undefined,
            value = undefined;
        if (item) {
            if (item.length > 0) {
                text = [];
                value = [];
                for (var i in item) {
                    text.push(item[i].text);
                    value.push(item[i].value);
                }
            } else {
                text = item.text;
                value = item.value;
            }

            if (this.state.type == 'single') {

                this.setState({ text: text, selected: [this.focus], selectedData: [item] }, function () {
                    _this8.toggleMenu();
                    _this8.props.onSelected ? _this8.props.onSelected(item) : '';
                });
            } else if (this.state.type == 'multiple') {
                (function () {
                    var _state = _this8.state;
                    var selectedData = _state.selectedData;
                    var data = _state.data;

                    var itemIndex = _this8.hasItemIndex(item);
                    var text = [],
                        selected = [];
                    // 如果已经被选中

                    if (itemIndex > -1) {
                        selectedData.splice(itemIndex, 1);
                    } else {
                        selectedData.push(item);
                    }

                    // 重新遍历data
                    _this8.loadData.forEach(function (option, index) {
                        selectedData.forEach(function (select) {
                            if (option.value == select.value) {
                                text.push(select.text);
                            }
                        });
                    });

                    data.forEach(function (option, index) {
                        selectedData.forEach(function (select) {
                            if (option.value == select.value) {
                                selected.push(index);
                            }
                        });
                    });
                    _this8.setState(_extends({}, _this8.state, {
                        text: text,
                        selected: selected,
                        selectedData: selectedData
                    }), function () {
                        _this8.props.onSelected ? _this8.props.onSelected(selectedData) : '';
                    });
                })();
            }
        }
    };

    Select.prototype.removeItem = function removeItem(index, e) {
        var _this9 = this;

        e.stopPropagation();
        var texts = this.state.text;
        var selected = this.state.selected;
        var selectedData = this.state.selectedData;

        if (index || index == 0) {
            texts.splice(index, 1);
            selected.splice(index, 1);
            selectedData.splice(index, 1);
        }
        this.setState(_extends({}, this.state, {
            text: texts,
            selected: selected,
            selectedData: selectedData
        }), function () {
            _this9.props.onSelected ? _this9.props.onSelected(selectedData) : '';
        });
    };

    Select.prototype.globalMouseClick = function globalMouseClick(event) {
        var _this10 = this;

        if (this.refs.myselect) {
            var target = event.target;
            var i = 0;
            var hideMenu = true;
            while (this.checkParentElement(target) && i < 10) {
                target = target.parentElement;
                i++;
                if (this.refs.myselect && target && target.innerHTML == this.refs.myselect.innerHTML) {
                    hideMenu = false;
                }
            }
            if (hideMenu && target.className != 'myselect-item' && target.className != 'myselect-item selected') {
                if (this.props.openSearch) {
                    if (this.props.type == "single") {
                        (function () {
                            var selected = [];
                            if (_this10.state.selectedData && _this10.state.selectedData.length > 0) {
                                var text = _this10.state.selectedData[0].text;
                                // 序列重置
                                _this10.loadData.map(function (item, index) {
                                    if (_this10.state.selectedData[0].value === item.value) {
                                        return selected.push(index);
                                    }
                                });
                                _this10.setState(_extends({}, _this10.state, {
                                    text: [text],
                                    data: _this10.loadData,
                                    selected: selected,
                                    open: false
                                }));
                            } else {
                                _this10.setState(_extends({}, _this10.state, {
                                    open: false
                                }));
                            }
                        })();
                    } else if (this.props.type == "multiple") {
                        (function () {
                            var selected = [],
                                text = [];
                            if (_this10.state.selectedData && _this10.state.selectedData.length > 0) {
                                // 序列重置
                                _this10.loadData.map(function (item, index) {
                                    _this10.state.selectedData.forEach(function (select) {
                                        if (select.value === item.value) {
                                            selected.push(index);
                                            text.push(select.text);
                                        }
                                    });
                                });
                                _this10.setState(_extends({}, _this10.state, {
                                    text: text,
                                    data: _this10.loadData,
                                    selected: selected,
                                    open: false
                                }));
                            } else {
                                _this10.setState(_extends({}, _this10.state, {
                                    open: false
                                }));
                            }
                        })();
                    }
                } else {
                    this.setState(_extends({}, this.state, {
                        open: false
                    }));
                }
            }
        }
    };

    Select.prototype.checkParentElement = function checkParentElement(target) {
        if (target.parentElement != null) {
            return true;
        } else {
            return false;
        }
    };

    Select.prototype.selectAll = function selectAll(e) {
        e.stopPropagation();
        var data = [].concat(this.state.data);
        var text = [],
            selected = [];

        if (data.length > 0) {
            data.forEach(function (item, index) {
                text.push(item.text);
                selected.push(index);
            });
        }

        this.setState(_extends({}, this.state, {
            text: text,
            selected: selected,
            selectedData: data
        }));
    };

    Select.prototype.unSelectAll = function unSelectAll(e) {
        e.stopPropagation();
        this.setState(_extends({}, this.state, {
            text: [],
            selected: [],
            selectedData: []
        }));
    };

    Select.prototype.render = function render() {
        var _props = this.props;
        var style = _props.style;
        var width = _props.width;

        var otherProps = _objectWithoutProperties(_props, ['style', 'width']);

        if (width) {
            if (style && style.width) {
                style.width = width;
            } else {
                style = _Object$assign({}, { width: width });
            }
        }
        return _react2['default'].createElement(
            'div',
            _extends({}, otherProps, { style: style, ref: 'myselect', className: this.props.className ? "myselect " + this.props.className : "myselect" }),
            this._generateHead(),
            _react2['default'].createElement(
                'div',
                { style: this.state.open && !this.props.disabled ? {} : { display: 'none' } },
                this._generateBody()
            )
        );
    };

    return Select;
})(_react2['default'].Component);

Select.propTypes = {
    /**
     * 最大高度，超过出现滚动条
     * {number}
     */
    maxHeight: _react2['default'].PropTypes.number,
    /**
     * 宽度
     * {number|string}
     */
    width: _react2['default'].PropTypes.oneOfType([_react2['default'].PropTypes.string, _react2['default'].PropTypes.number]),
    /**
     * 是否开启搜索
     * {boolean}
     */
    openSearch: _react2['default'].PropTypes.bool,
    /**
     * select 类型 ， single -> 单选(默认)，multiple -> 复选
     * {[type]}
     */
    type: _react2['default'].PropTypes.oneOf(["single", "multiple"]),
    /**
     * onSelect 选中事件
     */
    onSelected: _react2['default'].PropTypes.func,
    /**
     * 设置选中序列号
     * {number | array}
     */
    selected: _react2['default'].PropTypes.oneOfType([_react2['default'].PropTypes.array, _react2['default'].PropTypes.number]),
    /**
     * 设置所选中的值
     * {string | array}
     */
    value: _react2['default'].PropTypes.oneOfType([_react2['default'].PropTypes.array, _react2['default'].PropTypes.string]),
    /**
     * @private
     * 禁用
     */
    disabled: _react2['default'].PropTypes.bool,
    /**
     * 是否显示图标
     * {Boolean}
     */
    hasIcon: _react2['default'].PropTypes.bool,
    /**
     * 是否打开
     * {Boolean}
     */
    open: _react2['default'].PropTypes.bool,
    /**
     * 是否选中全部
     * {boolean}
     */
    selectAll: _react2['default'].PropTypes.bool,
    /**
     * 搜索开启，无查找内容提示语
     * {string}
     */
    noSearchDataTips: _react2['default'].PropTypes.string,
    /**
     * 复选显示在输入框size
     * {number}
     */
    showMultipleSize: _react2['default'].PropTypes.number,
    /**
     * 复选选项超出size,显示的文本
     * {string}
     */
    outSelectSizeText: _react2['default'].PropTypes.string
};

Select.defaultProps = {
    open: false,
    noSearchDataTips: '没有找到相关数据',
    hasIcon: false,
    selectAll: false,
    type: "single",
    showMultipleSize: -1, // 不限
    maxHeight: 180,
    openSearch: false,
    outSelectSizeText: 'selected...'
};

exports['default'] = Select;
module.exports = exports['default'];